<%@page import="com.edeal.frontline.helper.CTIHelper"%>
<%@page import="com.edeal.frontline.services.cti.CTIServiceClient"%>
<%
	/******************************************************************************
 * Copyright (c) 2000-2004 e-Deal
 *
 * e-Deal S.A.
 * 55 rue Brillat Savarin
 * 75013 Paris
 * France
 *
 * T: +33 (0)1 53 80 80 30
 * F: +33 (0)1 73 01 69 77
 * http://www.e-deal.com
 * 
 * La diffusion de ce code source sous quelque forme que ce soit sans
 * l'autorisation de E-DEAL est interdite.
 *
 * Vous êtes autorisés à modifier ce code source uniquement pour votre usage
 * propre et sous réserve que les mentions de copyright demeurent intactes.
 *
 * Ce code est fourni en l'état. Aucune garantie d'aucune sorte, explicite ou
 * implicite n'est donnée. En aucun cas E-DEAL ne pourra être tenu pour
 * responsable des dommages pouvant résulter de l'utilisation de ce code
 * source.
 *
 * CVS Info for $RCSfile: call.jsp,v $
 *
 * $Revision: 1.21 $
 * $Author: ghazig $                  $Date: 2012-05-23 11:57:48 $
 ******************************************************************************/
%><%@page session="true" pageEncoding="UTF-8"
	import="com.edeal.frontline.*,java.util.*,com.edeal.frontline.navigation.*,com.edeal.frontline.helper.ActorBaseHelper"%>
<%@taglib uri="http://www.e-deal.com/taglib/fl" prefix="fl"%>

<%!private String formatPhone(String pFmt, String pPhone) {
	String strResult = "";
	for (int i = 0, j = -1; i < pFmt.length(); i++) {
		char c = pFmt.charAt(i);
		if (c == '?') {
			for (j++; j < pPhone.length()
					&& !(((c = pPhone.charAt(j)) >= '0' && c <= '9') || c == '_'); j++)
				;
			if (j < pPhone.length())
				strResult += c;
		} else {
			strResult += c;
		}
	}
	return strResult;
}%>
<%
	final org.apache.commons.logging.Log logger = org.apache.commons.logging.LogFactory.getLog(getClass());
	String contextPath = (String) session.getAttribute("contextPath");
	FlContext context = null;
	if (contextPath != null) {
		context = Frontline.getContext(contextPath);
	} else {
		context = Frontline.getContext(request.getContextPath());
	}
	DataDictionary dico = context.getDataDictionary();
	boolean isPostgreSQL = context.isDbPostgreSQL();
	boolean isOracle = context.isDbOracle();
	String pPhone = Utils.getRequestParameter(context, request, "phone");
	if (pPhone == null || "null".equalsIgnoreCase(pPhone)) {
		pPhone = "";
	}
	String pRef = Utils.getRequestParameter(context, request, "ref");

	if (pRef == null) {
		pRef = "";
	}
	
	boolean isC3TCTI = false;
	try {
		CTIServiceClient cti = (CTIServiceClient)context.getServiceManager().getServiceClient(session, "CTI");
		if (cti != null) {
			String idService = cti.getProviderId();
			isC3TCTI = "C3T".equalsIgnoreCase(idService);
		}
	} catch (Exception e) {
	}
	
	String actID = (String)session.getAttribute("actorID");
	boolean actHasCTILic;
	try {
		actHasCTILic = ((Boolean)session.getAttribute("actorHasCTI")).booleanValue();
	} catch (Exception e) {
		// Lic V3 version.
		actHasCTILic = context.getLicenceManager().actorHasSoftware(actID, CTIServiceClient.CTI_LIC_CODE, LicenceManager.LicenceType.PermanentLicence, null);
		session.setAttribute("actorHasCTI", new Boolean(actHasCTILic));
	}

	boolean isMasked = pPhone == null || "".equals(pPhone.trim());
	boolean isIdentified = false;
	boolean isUnknown = false;
		
	FlRequest flRequest = new FlRequest(request);
	
	Vector vectObjs = (Vector) request.getAttribute("vectObjs");
	if (vectObjs == null){
	 vectObjs = new Vector();
	}
	
	Boolean isU, isM, isI;
	
	isU = (Boolean) request.getAttribute("isUnknown");
	isM = (Boolean) request.getAttribute("isMasked");
	isI = (Boolean) request.getAttribute("isIdentified");
	
	if (isU!=null) isUnknown = (isU).booleanValue();
	if (isM!=null) isMasked = (isM).booleanValue();
	if (isI!=null) isIdentified = (isI).booleanValue();
	
	String pCut = flRequest.getRequestParameterOrAttribute("cut");
%>
<html>
	<head>
		<title><fl:getMessage code="L2025" alt="E-DEAL" /> CRM - <%= Utils.formatToWeb(pPhone, false) %></title>
		<link rel="stylesheet" type="text/css" href="<fl:webapp/>/css/common_css.jsp">
		<link rel="stylesheet" type="text/css" href="<fl:webapp/>/css/master_css.jsp">
		<link href="<fl:webapp/>/css/smalltabs_css.jsp" rel="stylesheet" type="text/css">
		<script type="text/javascript" language="javascript" src="<fl:webapp/>/js/master_js.jsp"></script>
		<script language="javascript" src="<fl:webapp/>/js/format_tel.jsp"></script>
		<script language="javascript" src="<fl:webapp/>/js/utils.js"></script>
		<script language="javascript">
			var pRef = '<%= pRef %>';
	
			function openAnnuaire() {
				window.open('<fl:webapp/>/cti/annuaire.jsp', 'Annuaire', 'menubar=no,status=yes,toolbar=no,scrollbars=yes,resizable=yes,width=' + (screen.width * 3/4) + ',height=' + (screen.height * 3 / 4) + ',left=0,top=0');
			}
			
			function doSelect(pObj, pID, pPhone) {
				pPhone = doEpurePhone2(pPhone);
				var url = '<fl:webapp/>/cti_popup.fl?type='+flEscape(pObj) + '&id=' + flEscape(pID) + '&phone=' + flEscape(pPhone) + '&ref=<%= WebUtils.urlEncode(context, pRef) %>';
				doAjax(url);
				C3TAnswerCall();
			}
	
			function refreshSolicitant(cut){
				if (cut == '2'){
					_grid__Solicitant2_js_.callAjaxForHtml(_grid__Solicitant2_js_.getAjaxUrl(),{ "phone":'<%=pPhone%>',"ref":'<%= pRef %>' },false); 
				} else{
					_grid__Solicitant3_js_.callAjaxForHtml(_grid__Solicitant3_js_.getAjaxUrl(),{ "phone":'<%=pPhone%>',"ref":'<%= pRef %>'},false); 
				}
			}
	
			function doTransferCall() {
				window.open('<fl:webapp/>/select_actor_C3T_cti.fl?ref=<%= pRef %>', 'SelectActorCI', 'menubar=no,status=yes,toolbar=no,scrollbars=yes,resizable=yes,width=500,height=600');
			}
		
			//C3T functions
			function C3TAnswerCall() {
				window.opener.C3TConnector().answerCall();
			}
			
			function C3TMakeCall(recipient) {
				window.opener.C3TConnector().makeCall(recipient);
			};
			
			function C3TToggleHold() {
				window.opener.C3TConnector().toggleHold();
			};
			
			function C3TDropCall() {
				window.opener.C3TConnector().dropCall();
			};
			
			function C3TInitiateTransfer(recipient) {
				window.opener.C3TConnector().initiateTransfer(recipient);
			};
			
			function C3TCompleteTransfer() {
				window.opener.C3TConnector().completeTransfer();
			};
			
			
			$(document).ready(function() {
				_grid__Solicitant2_js_.callAjaxForHtml(_grid__Solicitant2_js_.getAjaxUrl(),{ "phone":'<%=pPhone%>',"ref":'<%= pRef %>' },false);
			});
		</script>
	</head>

	<body style="overflow: auto;">
		<div id="object_css"
			style="top: 0px; left: 0px; bottom: 0px; height: 100%;">
			<fl:bigTabs	objectTitle="<%=Utils.getMessage(session, \"L62BE\", false, true, \"Appel entrant\")%>">
				<table class="container" style="width: 100%; margin-top: 10px;">
					<tr>
						<!-- <td class="titrePartie" style="width: 100%" > -->
						<td id="tdCallInfo" class="titrePartie">
							<% if (isUnknown) { %>
								<fl:getMessage code="L62BE" alt="Appel entrant" /><%= isUnknown ? " inconnu&nbsp;&nbsp;&nbsp;&nbsp;N°" : ""%><%= (pPhone == null || "".equals(pPhone)) ? "&nbsp;masqué"  : pPhone  %>
							<% } else { %>
								<fl:getMessage code="L62BE" alt="Appel entrant" /><%="&nbsp;&nbsp;&nbsp;N°&nbsp;" + ((pPhone == null || "".equals(pPhone)) ? "&nbsp;masqué"  : pPhone) %>
							<%}%>
						</td>
					</tr>
					<tr><td class="ligne_separation_couleur"></td></tr>
					<tr><td class="ligne_separation">&nbsp;</td></tr>
					<tr>
						<td>
							<span class="button"> <a href="javascript:openAnnuaire();"><fl:getMessage
										code="L6205" alt="Annuaire" />
							</a> </span>
						</td>
					</tr>
					<tr>
						<td>
							<img src="icons/nav/spacer.gif" width="12" height="12">
						</td>
					</tr>
					<tr>
						<td>
							<span class="button">
								<a id="doAnswerLink" href="javascript:C3TAnswerCall()"><fl:getMessage code="L6430" alt="Décrocher"/></a>
							</span>
							<img src="icons/nav/spacer.gif" width="12" height="12">
							<span class="button">
								<a href="javascript:doTransferCall()"><fl:getMessage code="L7001" alt="Initier transfert"/>...</a>
							</span>
							<img src="icons/nav/spacer.gif" width="12" height="12">
							<span class="button">
								<a href="javascript:C3TCompleteTransfer()"><fl:getMessage code="XXXXX" alt="Compléter le transfert" /></a>
							</span>
							<img src="icons/nav/spacer.gif" width="12" height="12">
							<span class="button">
								<a href="javascript:C3TToggleHold()"><fl:getMessage code="L7002" alt="Mettre en attente" /> / <fl:getMessage code="L7003" alt="Reprendre appel" /></a>
							</span>
							<img src="icons/nav/spacer.gif" width="12" height="12">
							<span class="button">
								<a href="javascript:C3TDropCall()"><fl:getMessage code="L70C3" alt="Raccrocher"/></a>
							</span>
							<img src="icons/nav/spacer.gif" width="12" height="12">
						</td>
					</tr>
					<tr>
						<td>
							<img src="icons/nav/spacer.gif" width="12" height="12">
						</td>
					</tr>
					<tr class="ligne_separation">
						<td>
						</td>
					</tr>
				</table>

				<!-- show caller information; using grids -->
				<%if (!isMasked){
					if (isUnknown){ %>
						<fl:smallTabs name="NumApproch">
							<fl:sTab id="Sol2" onselect="refreshSolicitant(2)"
								title="<%=Utils.getMessage(session, \"L642E\", false, true, \"Numéros approchant à 2 chiffres\")%>">
								<div>
								<fl:grid name="Solicitant2" height="200" ajaxUrl="/list_solicitant.fl?cut=2"/>
								
								</div>
							</fl:sTab>
							<fl:sTab id="Sol3" onselect="refreshSolicitant(3)"
								title="<%=Utils.getMessage(session, \"L642F\", false, true, \"Numéros approchant à 3 chiffres\")%>">
								<div>
								<fl:grid name="Solicitant3" height="200" ajaxUrl="/list_solicitant.fl?cut=3"/>
									
								</div>
							</fl:sTab>
						</fl:smallTabs>
					<% } else { %>
						<fl:smallTabs name="Num">
							<fl:sTab hideLink="true" id="nume"
								title="<%= Utils.getMessage(session, \"M1009\", false, true, \"Solliciteur\") %>">
								<div>
									<fl:grid name="Solicitant2" height="200" ajaxUrl="/list_solicitant.fl"/>
									
								</div>
							</fl:sTab>
						</fl:smallTabs>

					<%}
				}%>
				<table class="container" width="100%" style="margin-top: 5px;">
					<tr>
						<td colspan="2" style="text-align: center;">
							<a href="javascript:window.close()"><img
									src="<fl:webapp/>/icons/ico/fermer_red_long.gif">
							</a>
						</td>
					</tr>
				</table>  
			</fl:bigTabs>
		</div>
	</body>
</html>